Loading...
Searching...
No Matches
dolfin::LinearAlgebraObject Class Referenceabstract

`#include <LinearAlgebraObject.h>`

Inheritance diagram for dolfin::LinearAlgebraObject:
[legend]
Collaboration diagram for dolfin::LinearAlgebraObject:
[legend]

## Public Member Functions

virtual const LinearAlgebraObject * | instance () const
| Return concrete instance / unwrap (const version).
virtual LinearAlgebraObject * | instance ()
| Return concrete instance / unwrap (non-const version).
virtual std::shared_ptr< const LinearAlgebraObject > | shared_instance () const
| Return concrete shared ptr instance / unwrap (const version).
virtual std::shared_ptr< LinearAlgebraObject > | shared_instance ()
| Return concrete shared ptr instance / unwrap (non-const version).
virtual MPI_Comm | mpi_comm () const =0
| Return MPI communicator.
Public Member Functions inherited from dolfin::Variable
| Variable ()
| Create unnamed variable.
| Variable (const std::string name, const std::string label)
| Create variable with given name and label.
| Variable (const Variable &variable)
| Copy constructor.
virtual | ~Variable ()
| Destructor.
const Variable & | operator= (const Variable &variable)
| Assignment operator.
void | rename (const std::string name, const std::string label)
| Rename variable.
std::string | name () const
| Return name.
std::string | label () const
| Return label (description).
std::size_t | id () const
virtual std::string | str (bool verbose) const
| Return informal string representation (pretty-print).

## Additional Inherited Members

Public Attributes inherited from dolfin::Variable
Parameters | parameters
| Parameters.

## Detailed Description

This is a common base class for all DOLFIN linear algebra objects. In particular, it provides casting mechanisms between different types.

## Member Function Documentation

## instance() [1/2]

virtual LinearAlgebraObject * dolfin::LinearAlgebraObject::instance | ( |  | ) |

inline virtual

Return concrete instance / unwrap (non-const version).

Reimplemented in dolfin::LinearOperator, dolfin::Matrix, and dolfin::Vector.

## instance() [2/2]

virtual const LinearAlgebraObject * dolfin::LinearAlgebraObject::instance | ( |  | ) | const

inline virtual

Return concrete instance / unwrap (const version).

Reimplemented in dolfin::LinearOperator, dolfin::Matrix, and dolfin::Vector.

## mpi_comm()

virtual MPI_Comm dolfin::LinearAlgebraObject::mpi_comm | ( |  | ) | const

pure virtual

Return MPI communicator.

Implemented in dolfin::EigenMatrix, dolfin::EigenVector, dolfin::GenericLinearAlgebraFactory::NotImplementedLinearOperator, dolfin::LinearOperator, dolfin::Matrix, dolfin::PETScLinearOperator, dolfin::PETScMatrix, dolfin::PETScVector, dolfin::Scalar, dolfin::TpetraMatrix, dolfin::TpetraVector, and dolfin::Vector.

## shared_instance() [1/2]

virtual std::shared_ptr< LinearAlgebraObject > dolfin::LinearAlgebraObject::shared_instance | ( |  | ) |

inline virtual

Return concrete shared ptr instance / unwrap (non-const version).

Reimplemented in dolfin::LinearOperator, dolfin::Matrix, and dolfin::Vector.

## shared_instance() [2/2]

virtual std::shared_ptr< const LinearAlgebraObject > dolfin::LinearAlgebraObject::shared_instance | ( |  | ) | const

inline virtual

Return concrete shared ptr instance / unwrap (const version).

Reimplemented in dolfin::LinearOperator, dolfin::Matrix, and dolfin::Vector.

The documentation for this class was generated from the following file:

- /build/dolfin-lFBzDh/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/la/LinearAlgebraObject.h